Subject: Re: [PATCH] vlan: lockdep subclass for ppp _xmit_lock Re: ppp_generic: fix lockdep warning

From: Jarek Poplawski <[email-masked]>
Date: Thu, 10 May 2007 07:30:52 +0200

On Thu, May 10, 2007 at 12:06:09AM +0400, Yuriy N. Shkandybin wrote:
> After applying this patch i've got this:
> 
> =======================================================
> [ INFO: possible circular locking dependency detected ]
> 2.6.21-gentoo #2
> -------------------------------------------------------
> ospfd/3984 is trying to acquire lock:
> (&ppp->wlock){-...}, at: [<ffffffff803512a0>] ppp_xmit_process+0x20/0x4f0
> 
> but task is already holding lock:
> (&dev->_xmit_lock){-+..}, at: [<ffffffff8038d778>] __qdisc_run+0x88/0x1c3
> 
> which lock already depends on the new lock.

Thanks Yuriy!

As a matter of fact I suspected there will be something more.
Lockdep always stops working after the first warning, and you
have some very interesting (entangled) configuration, so each
fix could uncover new warnings.

I need some time to figure out this one, so I'd try to use your
help yet... I hope it's only about lockdep warnings and there
are no real lockups.

Best regards,
Jarek P.